using System;
using System.Drawing;
using System.Windows.Forms;

public class AppForm : Form
{
    private ControlPanel cp;
    private ViewPanel vp;
    private ResolutionPanel rp;
    private BezierModel b;

    public AppForm()
    {
        this.Text = "Bezier Splines";
        this.Size = new Size(850, 600);
        
        this.b = new BezierModel();

        // Add controls
        this.cp = new ControlPanel();
        this.cp.Dock = DockStyle.Top;
        // this.cp.BackColor = Color.Red;      // debug

        this.vp = new ViewPanel(this.b);
        this.vp.Dock = DockStyle.Fill;

        this.rp = new ResolutionPanel();
        this.rp.Dock = DockStyle.Bottom;
        // this.rp.BackColor = Color.Blue;     // debug
        
        // Connect events
        this.b.StateChanged += new StateChangedHandler(this.vp.Invalidate);

        this.cp.DisplayOptionsChanged += new DisplayOptionsChangedHandler(this.vp.ChangeDiplayOptions);
        this.cp.Clear += new ClearHandler(this.b.Clear);
        this.cp.ModeChanged += new ModeChangedHandler(this.b.SetMode);

		this.vp.MouseMove += new MouseEventHandler(this.cp.SetXY);

		this.rp.TChanged += new ResolutionPanel.TChangedHandler(this.b.SetT);
		this.rp.ResolutionChanged += new ResolutionPanel.ResolutionChangedHandler(this.b.SetResolution);

        this.Controls.Add(this.vp);
        this.Controls.Add(this.cp);        
        this.Controls.Add(this.rp);		
    }
}