using System;
using System.Drawing;
using System.Windows.Forms;

class ResolutionPanel : Panel
{
   private Label lResolution, lT;
   private TrackBar tResolution, tT;
   public delegate void ResolutionChangedHandler (int res);
   public delegate void TChangedHandler(double t);
   
   public event ResolutionChangedHandler ResolutionChanged;
   public event TChangedHandler TChanged;

    // C'tor
    public ResolutionPanel()
    {
		int margin = 5;
		int trackBarWidth = 300;
		// this.BackColor = Color.SlateGray;
		
		// Add Controls
		Label l = new Label();
		l.Width = 60;
		l.Text = "Resolution";
		l.Location = new Point(margin, margin);
		this.Controls.Add(l);
		
		this.lResolution = new Label();
		this.lResolution.BorderStyle = BorderStyle.Fixed3D;
		this.lResolution.TextAlign = ContentAlignment.MiddleCenter;
		this.lResolution.Width = 30;
		this.lResolution.Location = new Point(l.Right + margin, margin);
		this.lResolution.Text = "50";
		this.Controls.Add(this.lResolution);

		this.tResolution = new TrackBar();
        this.tResolution.Width = trackBarWidth;
		this.tResolution.Location = new Point(this.lResolution.Right + margin, margin);
		this.tResolution.Minimum = 0;
        this.tResolution.Maximum = 100;
        this.tResolution.Value = 50;
        this.tResolution.ValueChanged += new EventHandler(this.refreshResolution);
		this.Controls.Add(this.tResolution);

		l = new Label();
		l.Text = "t";
        l.Width = 15;
		l.Location = new Point(this.tResolution.Right + margin, margin);
		this.Controls.Add(l);
		
		this.lT = new Label();
		this.lT.BorderStyle = BorderStyle.Fixed3D;
        this.lT.Width = 30;
        this.lT.TextAlign = ContentAlignment.MiddleCenter;
		this.lT.Location = new Point(l.Right + margin, margin);
		this.lT.Text = "0.5";
		this.Controls.Add(this.lT);

		this.tT = new TrackBar();
        this.tT.Minimum = 0;
        this.tT.Maximum = 100;
        this.tT.Value = 50;
		this.tT.Location = new Point(this.lT.Right + margin, margin);
        this.tT.Width = trackBarWidth;
        this.tT.ValueChanged += new EventHandler(this.refreshT);
		this.Controls.Add(this.tT);

        this.Height = margin * 2 + l.Height;
    }
    
    private void refreshResolution(object o, EventArgs e)
    {
        int res = this.tResolution.Value;
        
        this.lResolution.Text = res.ToString();
        
        if (this.ResolutionChanged != null)
            this.ResolutionChanged(res);
    }
    
    private void refreshT(object o, EventArgs e)
    {
        double t = ((double)this.tT.Value) / 100;
        
        this.lT.Text = t.ToString();

        if (this.TChanged != null)
            this.TChanged(t);
    }
}